
//+------------------------------------------------------------------+
//|                                              Copyright 2010, Kos |
//|                                      http://mql5.com/ru/users/kos|
//+------------------------------------------------------------------+
//|     : 01.01.2010                                           |
//|   :          |
//|                PriceAction.                      |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "2010, Kos"

#include <JCPE\Var.mqh>

#import "JCPDS.ex5"
 string  DefineStrings(int LangID,int uid); 
#import
 
   
//+------------------------------------------------------------------+
//|   ""," "                 |
//+------------------------------------------------------------------+
   
string HM_Desc(int id,int Lang)
   {
    string Desc;
    int  MM;
     if (id>2000 && id<3000) Desc=DefineStrings(Lang,5002);
       else Desc=DefineStrings(Lang,5003);
     MM=(int)MathMod(id,1000);
      if (MM>500)                            Desc=Desc+DefineStrings(Lang,5010);   //  
      if (Custom.DataRange(EngulfingArray,MM))      
       {
        Desc=Desc+DefineStrings(Lang,5027);   //
        if (MM==303 ||MM==304 || MM==305 || MM==306 || MM==803 ||MM==804 || MM==805 || MM==806) Desc=Desc+DefineStrings(Lang,5023);   //  
       }
       else
       {
        if((MM>100 && MM<200) && 
           (MM>600 && MM<700))                       Desc=Desc+DefineStrings(Lang,5023);   //                   
       }
      
      MM=(int)MathMod(id,100);
      if (MM==13||MM==14||MM==15||MM==16)            Desc=Desc+DefineStrings(Lang,5014);   //
       else
        {
         if (MM==23||MM==24||MM==25||MM==26)         Desc=Desc+DefineStrings(Lang,5015);   // ..
          else
           {
            if (MM==43||MM==44||MM==45||MM==46)      Desc=Desc+DefineStrings(Lang,5016);   // ..
             else 
              {
               if (MM>=63 && MM<=96)                 Desc=Desc+DefineStrings(Lang,5020);   //   
              }
           }
        }  
      
      if(Custom.DataRange(StarsArray,id))           Desc=Desc+DefineStrings(Lang,5012);   //  
      
      return(Desc);
   } 
    
//+------------------------------------------------------------------+
//|   ""," "               |
//+------------------------------------------------------------------+

string SS_Desc(int id,int Lang)
   {
    string Desc;
    int  MM;
     
     if (id>4000 && id<5000) Desc=DefineStrings(Lang,5000);
       else Desc=DefineStrings(Lang,5001);
      
      MM=(int)MathMod(id,1000);
      if (MM>500)                            Desc=Desc+DefineStrings(Lang,5010);   //  
      if (Custom.DataRange(EngulfingArray,MM))      
       {
        Desc=Desc+DefineStrings(Lang,5028);   //
        if (MM==303 || MM==304 || MM==305 || MM==306 || MM==803 || MM==804 || MM==805 || MM==806) Desc=Desc+DefineStrings(Lang,5023);   //  
       }
       else
       {
        if((MM>100 && MM<200) && 
           (MM>600 && MM<700))                       Desc=Desc+DefineStrings(Lang,5023);   //                   
       }
      
      MM=(int)MathMod(id,100);
      if (MM==13||MM==14||MM==15||MM==16)            Desc=Desc+DefineStrings(Lang,5014);   //
       else
        {
         if (MM==23||MM==24||MM==25||MM==26)         Desc=Desc+DefineStrings(Lang,5015);   // ..
          else
           {
            if (MM==43||MM==44||MM==45||MM==46)      Desc=Desc+DefineStrings(Lang,5016);   // ..
             else 
              {
               if (MM>=63 && MM<=96)                 Desc=Desc+DefineStrings(Lang,5021);   //   
              }
           }
        }  
      
      if(Custom.DataRange(StarsArray,id))           Desc=Desc+DefineStrings(Lang,5013);   //  
     
      return(Desc); 
   }  
     
//+------------------------------------------------------------------+
//|   "/ ","3   " |
//+------------------------------------------------------------------+

string EMS_Desc(int id,int Lang)
   {
    string Desc;
    int  MM;
     
     MM=(int)MathMod(id,10);
     if (MM==5) return(DojiStar_Desc(id,Lang));
     if (MM==3) return(Piegon_Desc(id,Lang));
     
     MM=(int)MathMod(id,100);
     if (MM==10 || MM==20) return(ThreeStars_Desc(id,Lang,MM));
     
     if (id>5000 && id<6000) Desc=DefineStrings(Lang,5005);
      else   Desc=DefineStrings(Lang,5004);
      
      MM=(int)MathMod(id,1000);
      if (MM==800 || MM==300) Desc=Desc+DefineStrings(Lang,5044);
       else
        {
         if (MM>700) Desc=Desc+DefineStrings(Lang,5017); 
          else 
          {
           if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
            else
            {
              if (MM>200) Desc=Desc+DefineStrings(Lang,5011);
            }
          }
        }   
     return(Desc);     
   }
   
//+------------------------------------------------------------------+
//|   "3   /",""          |
//+------------------------------------------------------------------+

string IN_Desc(int id,int Lang)
   {
    string Desc;
     if (id >502 && id<600) Desc=DefineStrings(Lang,5019)+DefineStrings(Lang,5010);
      else
      {
       if (id >600 && id<700) Desc=DefineStrings(Lang,5018)+DefineStrings(Lang,5010);
        else
        {
         if(id==501) Desc=DefineStrings(Lang,5051);
          else 
           {
            if(id==502) Desc=DefineStrings(Lang,5052);
             else
              {
               if(id==60 || id==70 || id==80 || id==90) Desc=DefineStrings(Lang,5019);
                else
                 {
                  if(id==110 || id==120 || id==130 || id==140) Desc=DefineStrings(Lang,5018);
                 }
              }
           } 
        
        }
      }
     return(Desc);
   }

//+------------------------------------------------------------------+
//|  : "3   /",                 |
//|                      " "                      |
//+------------------------------------------------------------------+

string OUT_Desc(int id,int Lang)
   {
    string Desc;
     switch(id)
        {
         //LE
         case 9000: Desc=DefineStrings(Lang,5045);                           break;
         case 9500: Desc=DefineStrings(Lang,5045)+DefineStrings(Lang,5010);  break;
         case 9100: Desc=DefineStrings(Lang,5046);                           break;
         case 9600: Desc=DefineStrings(Lang,5046)+DefineStrings(Lang,5010);  break;
         //OUT
         case 9400: Desc=DefineStrings(Lang,5029);                           break;
         case 9401: Desc=DefineStrings(Lang,5029)+DefineStrings(Lang,5050);  break;
         case 9402: Desc=DefineStrings(Lang,5029)+DefineStrings(Lang,5050);  break;
         case 9450: Desc=DefineStrings(Lang,5030);                           break;
         case 9451: Desc=DefineStrings(Lang,5030)+DefineStrings(Lang,5049);  break;
         case 9452: Desc=DefineStrings(Lang,5030)+DefineStrings(Lang,5049);  break;
         case 9900: Desc=DefineStrings(Lang,5029)+DefineStrings(Lang,5010);  break;
         case 9901: Desc=DefineStrings(Lang,5029)+DefineStrings(Lang,5050)+DefineStrings(Lang,5010);  break;
         case 9902: Desc=DefineStrings(Lang,5029)+DefineStrings(Lang,5050)+DefineStrings(Lang,5010);  break;
         case 9950: Desc=DefineStrings(Lang,5030)+DefineStrings(Lang,5010);  break;
         case 9951: Desc=DefineStrings(Lang,5030)+DefineStrings(Lang,5049)+DefineStrings(Lang,5010);  break;
         case 9952: Desc=DefineStrings(Lang,5030)+DefineStrings(Lang,5049)+DefineStrings(Lang,5010);  break;
        }
    return(Desc);
   }
   
//+------------------------------------------------------------------+
//|  "  "                                 |
//+------------------------------------------------------------------+

string BH_Desc(int id,int Lang,int Num,int Turn)
   {
    string Desc;
    int MM;
   
   switch(Turn)
   {
    case DOWN_TURN:
                 switch (Num)
                  {
                   case 98: Desc=DefineStrings(Lang,5047)+"/"+DefineStrings(Lang,5037);break; 
                   case 99: Desc=DefineStrings(Lang,5047);                             break;
                  }
    break;
   
    case UP_TURN:
                 switch (Num)
                  {
                   case 98: Desc=DefineStrings(Lang,5048)+"/"+DefineStrings(Lang,5040);break; 
                   case 99: Desc=DefineStrings(Lang,5048);                             break;
                  }
    break;
   } 
    MM=(int)MathMod(id,1000);
    if (MM>600) Desc=Desc+DefineStrings(Lang,5023)+DefineStrings(Lang,5010);
     else 
      {
       if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
         else
          {
           if (MM>100) Desc=Desc+DefineStrings(Lang,5023);
          }
      }
    return(Desc);
   }

//+------------------------------------------------------------------+
//|   "   "," "              |
//+------------------------------------------------------------------+

string ThreeStars_Desc(int id,int Lang,int Num)
   {
     string Desc;
     int MM;
     
     switch(Num)
      {
       case 10: Desc=DefineStrings(Lang,5065); break;
       case 20: Desc=DefineStrings(Lang,5066); break;
      }
   
     MM=(int)MathMod(id,1000);
     if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
     return(Desc);   
   }

//+------------------------------------------------------------------+
//|   " "                                 |
//+------------------------------------------------------------------+

string DojiStar_Desc(int id,int Lang)
   {
     string Desc;
     int MM;
     Desc=DefineStrings(Lang,5067);
     MM=(int)MathMod(id,1000);
     if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
     return(Desc);   
   }

//+------------------------------------------------------------------+
//|   " "                             |
//+------------------------------------------------------------------+

string Piegon_Desc(int id,int Lang)
   {
     string Desc;
     int MM;
     Desc=DefineStrings(Lang,5068);
     MM=(int)MathMod(id,1000);
     if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
     return(Desc);   
   }   
   
//+------------------------------------------------------------------+
//|   " "                         |
//+------------------------------------------------------------------+

string ML_Desc(int id,int Lang,int Num,int Turn)
   {
    string Desc;
    int MM;
    
   switch(Turn)
   {
    case DOWN_TURN:
                 switch (Num)
                  {
                   case 90: Desc=DefineStrings(Lang,5057);                             break; 
                   case 91: Desc=DefineStrings(Lang,5057)+DefineStrings(Lang,5049)+"/"+DefineStrings(Lang,5038);    break;
                   case 92: Desc=DefineStrings(Lang,5057)+DefineStrings(Lang,5049);    break;
                  }
    break;
   
    case UP_TURN:
                 switch (Num)
                  {
                   case 90: Desc=DefineStrings(Lang,5056);                             break; 
                   case 91: Desc=DefineStrings(Lang,5056)+DefineStrings(Lang,5050)+"/"+DefineStrings(Lang,5041);    break;
                   case 92: Desc=DefineStrings(Lang,5056)+DefineStrings(Lang,5050);    break;
                  }
    break;
   } 
   
   MM=(int)MathMod(id,1000);
    if (MM>600) Desc=Desc+DefineStrings(Lang,5010)+DefineStrings(Lang,5023);
     else 
      {
       if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
         else
          {
           if (MM>100) Desc=Desc+DefineStrings(Lang,5023);
          }
      }
    return(Desc);
   }  
    
//+------------------------------------------------------------------+
//|   "  ","  "          |
//+------------------------------------------------------------------+

string PL_Desc(int id,int Lang) 
   {
     string Desc;
     int  MM;
     
       MM=(int)MathMod(id,100);
       if ((MM==98) || (MM==99))                           return(BH_Desc(id,Lang,MM,DOWN_TURN)); 
       if ((MM==90) || (MM==91) || (MM==92))               return(ML_Desc(id,Lang,MM,DOWN_TURN));
       if ((MM==60) || (MM==63) || (MM==64))               return(DefineStrings(Lang,5053));
       if ((MM==70) || (MM==73) || (MM==74))               return(DefineStrings(Lang,5054));
       if ((MM==80) || (MM==83) || (MM==84))               return(DefineStrings(Lang,5055));
       if (MM==72)                                         return(Soldiers_Desc(id,Lang,MM));
       
       Desc=Desc+DefineStrings(Lang,5024); 
       MM=(int)MathMod(id,1000);
       if (MM>600) 
        {
         Desc=Desc+DefineStrings(Lang,5010)+DefineStrings(Lang,5023);
        }
        else 
        {
         if (MM>500) 
          {
            Desc=Desc+DefineStrings(Lang,5010);
          }
          else
          {
           if (MM>100) Desc=Desc+DefineStrings(Lang,5023);
          }
        }
        
        MM=(int)MathMod(id,10);
        if (MM==1) Desc=Desc+DefineStrings(Lang,5049)+" ("+DefineStrings(Lang,5037)+")";
          else 
          {
           if (MM==2) Desc=Desc+DefineStrings(Lang,5049);
          } 
     return(Desc);
   } 
   
//+------------------------------------------------------------------+
//|   "   ","  "   |
//+------------------------------------------------------------------+

string DCC_Desc(int id,int Lang) 
   {
     string Desc;
     int  MM;
      
      MM=(int)MathMod(id,100);
      if ((MM==98) || (MM==99))                           return(BH_Desc(id,Lang,MM,UP_TURN)); 
      if ((MM==90) || (MM==91) || (MM==92))               return(ML_Desc(id,Lang,MM,UP_TURN));
      if ((MM==70) || (MM==71) || (MM==72) || (MM==73))   return(Crows_Desc(id,Lang,MM));
      if ((MM==74) || (MM==75))                           return(Soldiers_Desc(id,Lang,MM));
      
      Desc=Desc+DefineStrings(Lang,5022);
      MM=(int)MathMod(id,1000); 
       if (MM>600) 
        {
         Desc=Desc+DefineStrings(Lang,5010)+DefineStrings(Lang,5023);
        }
        else 
        {
         if (MM>500) 
          {
            Desc=Desc+DefineStrings(Lang,5010);
          }
          else
          {
           if (MM>100)  Desc=Desc+DefineStrings(Lang,5023);
          }
        }
       MM=(int)MathMod(id,10);
        if (MM==1) Desc=Desc+DefineStrings(Lang,5050)+" ("+DefineStrings(Lang,5040)+")";
         else 
          {
           if (MM==2) Desc=Desc+DefineStrings(Lang,5050);
          } 
     return(Desc);
   }         
   
//+------------------------------------------------------------------+
//|  :"2 ,3 "                   |
//+------------------------------------------------------------------+

string Crows_Desc(int id,int Lang,int Num)   
   {
    string Desc;
    int MM;
    
    switch(Num)
     {
       case 70:  Desc=DefineStrings(Lang,5058); break;
       case 71:  Desc=DefineStrings(Lang,5059); break;
       case 72:  Desc=DefineStrings(Lang,5060); break;
       case 73:  Desc=DefineStrings(Lang,5061); break;
     }
     MM=(int)MathMod(id,1000); 
     if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
    return(Desc) ;
   }

//+------------------------------------------------------------------+
//|  :" ,,3 " |
//+------------------------------------------------------------------+

string Soldiers_Desc(int id,int Lang,int Num)   
   {
    string Desc;
    int MM;
    
    switch(Num)
     {
       case 72:  Desc=DefineStrings(Lang,5062); break;
       case 74:  Desc=DefineStrings(Lang,5063); break;
       case 75:  Desc=DefineStrings(Lang,5064); break;
     }
     
     MM=(int)MathMod(id,1000); 
     if (MM>600) Desc=Desc+DefineStrings(Lang,5010)+DefineStrings(Lang,5023);
      else
       {
        if (MM>500) Desc=Desc+DefineStrings(Lang,5010);
         else 
         {
          if (MM>600) Desc=Desc+DefineStrings(Lang,5023);
         }
       }
    return(Desc) ;
   }
      
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+

string PatternDesc(int id,int Lang) export 
   {
    string Desc=" ";
    
//  ,  
  
    if ((id>4000 && id<5000) || (id>1000 && id<2000))
     {
       return(SS_Desc(id,Lang));
     }
      
// ,  
      
    if (id>2000 && id<4000)
     {
       return(HM_Desc(id,Lang));
     } 

//  , , ,    , -   
           
   if (id>5000 && id<7000)
     {
       return(EMS_Desc(id,Lang));
     }
  
//    /,""  
           
   if (id<1000)
     {
       return(IN_Desc(id,Lang));
     } 

//   /,  
    
    if (id>=9000 && id<10000)
     {
      return(OUT_Desc(id,Lang)); 
     }     
     
//    ,"  "
    
    if (id>7000 && id<8000)
     {
      return(DCC_Desc(id,Lang));
     }
    
//   ,"  "
    
    if (id>8000 && id<9000)
     {
      return(PL_Desc(id,Lang));
     } 
     
    Desc=DefineStrings(id,Lang);
    return(Desc); 
  }
    
//+------------------------------------------------------------------+
//|     2        |
//+------------------------------------------------------------------+
    
string CandleDesc(int id,int Lang) export 
   {
    string Desc;
    switch(id)
     {
      case 10:  Desc=DefineStrings(Lang,5006);                               break;  // H
      case 11:  Desc=DefineStrings(Lang,5036);                               break;  // BeP
      case 20:  Desc=DefineStrings(Lang,5007);                               break;  // HPH
      case 21:  Desc=DefineStrings(Lang,5036)+DefineStrings(Lang,5014);      break;  // H+BeP
      case 22:  Desc=DefineStrings(Lang,5035);                               break;  // BuP
      case 31:  Desc=DefineStrings(Lang,5036)+DefineStrings(Lang,5015);      break;  // BeP+HPH
      case 32:  Desc=DefineStrings(Lang,5035)+DefineStrings(Lang,5014);      break;  // Bup+H
      case 40:  Desc=DefineStrings(Lang,5009);                               break;  // LpH
      case 42:  Desc=DefineStrings(Lang,5035)+DefineStrings(Lang,5015);      break;  // BuP+HPH
      case 50:  Desc=DefineStrings(Lang,5043);                               break;  // HW
      case 51:  Desc=DefineStrings(Lang,5036)+DefineStrings(Lang,5016);      break;  // Bep+LPH
      case 60:  Desc=DefineStrings(Lang,5006)+"/"+DefineStrings(Lang,5043);  break;  // H+HW
      case 62:  Desc=DefineStrings(Lang,5035)+DefineStrings(Lang,5016);      break;  // Bup+LPH
      case 70:  Desc=DefineStrings(Lang,5007)+"/"+DefineStrings(Lang,5043);  break;  // HPH+HW
      case 71:  Desc=DefineStrings(Lang,5033);                               break;  // GSDoji
      case 72:  Desc=DefineStrings(Lang,5034);                               break;  // LLDoji
      case 73:  Desc=DefineStrings(Lang,5031);                               break;  // ANYDoji
      case 74:  Desc=DefineStrings(Lang,5032);                               break;  // DFDoji
      case 80:  Desc=DefineStrings(Lang,5008);                               break;  // HC
      case 90:  Desc=DefineStrings(Lang,5009)+"/"+DefineStrings(Lang,5043);  break;  // LPH+HW
      case 100: Desc=DefineStrings(Lang,5037);                               break;  // BuM
      case 101: Desc=DefineStrings(Lang,5039);                               break;  // BuCM
      case 102: Desc=DefineStrings(Lang,5038);                               break;  // BuOM
      case 120: Desc=DefineStrings(Lang,5040);                               break;  // BeM
      case 121: Desc=DefineStrings(Lang,5041);                               break;  // BeOM
      case 122: Desc=DefineStrings(Lang,5042);                               break;  // BeCM
      case 6003:Desc=DefineStrings(Lang,5068);                               break;  // Piegon
      case 7040:Desc=DefineStrings(Lang,5022);                               break;  // DCC
      case 7160:Desc=DefineStrings(Lang,5022)+"/"+DefineStrings(Lang,5040);  break;  // DCC+BeM+BeBH(5050)
      case 7161:Desc=DefineStrings(Lang,5022)+"/"+DefineStrings(Lang,5041);  break;  // DCC+BeOM+BeBH(5050)
      case 7162:Desc=DefineStrings(Lang,5022)+"/"+DefineStrings(Lang,5042);  break;  // DCC+BeCM
      case 8040:Desc=DefineStrings(Lang,5024);                               break;  // PL
      case 8140:Desc=DefineStrings(Lang,5024)+"/"+DefineStrings(Lang,5037);  break;  // PL+BuM(5037)+BuBH(5049)
      case 8141:Desc=DefineStrings(Lang,5024)+"/"+DefineStrings(Lang,5039);  break;  // PL+BuOM(5039)+BuBH(5049)
      case 8142:Desc=DefineStrings(Lang,5024)+"/"+DefineStrings(Lang,5038);  break;  // PL+BuCM
      case 9200:Desc=DefineStrings(Lang,5026);                               break;  // BeEn
      case 9320:Desc=DefineStrings(Lang,5026)+"/"+DefineStrings(Lang,5040);  break;  // BeEn+BeM+BeBH(5050)
      case 9321:Desc=DefineStrings(Lang,5026)+"/"+DefineStrings(Lang,5041);  break;  // BeEn+BeOM+BeBH(5050)
      case 9322:Desc=DefineStrings(Lang,5026)+"/"+DefineStrings(Lang,5042);  break;  // BeEn+BeCM
      case 9300:Desc=DefineStrings(Lang,5025);                               break;  // BuEn
      case 9400:Desc=DefineStrings(Lang,5025)+"/"+DefineStrings(Lang,5037);  break;  // BuEn+BuM+BuBH(5049)
      case 9401:Desc=DefineStrings(Lang,5025)+"/"+DefineStrings(Lang,5039);  break;  // BuEn+BuOM+BuBH(5049)
      case 9402:Desc=DefineStrings(Lang,5025)+"/"+DefineStrings(Lang,5038);  break;  // BuEn+BuCM
      default:  Desc=" Unknow? ";                                            break;
     }            
    return(Desc);
   }                             