//+------------------------------------------------------------------+
//|                                                        JCPDS.mq5 |
//|                                              Copyright 2010, Kos |
//|                              https://login.mql5.com/ru/users/kos |
//+------------------------------------------------------------------+
#property library
#property copyright "2010,Kos"
#property link "https://login.mql5.com/ru/users/kos"
#property version   "1.00"

//+------------------------------------------------------------------+
//|                                                |
//|:                                                        |
//|  LangID-                                       |
//|       0-                                                  |
//|       1-  ..                                        |
//+------------------------------------------------------------------+
string DefineStrings(int LangID,int uid) export
   {
    string Description;
    
    if (LangID <0 || LangID >1)    LangID=0;

    switch(LangID)
    {
     case 0: //
       switch(uid)
        {
         case 5000:  Description="  ";                                       break;
         case 5001:  Description=" ";                                            break;
         case 5002:  Description=" ";                                                 break;
         case 5003:  Description="  ";                                    break;
         case 5004:  Description="  ";                                       break;
         case 5005:  Description="  ";                                       break;
         case 5006:  Description=" ";                                                break;
         case 5007:  Description="   ";                                   break;
         case 5008:  Description="  ";                                          break;
         case 5009:  Description="   ";                                    break;
         case 5010:  Description="/";                                                break;
         case 5011:  Description="/";                                                  break;
         case 5012:  Description="/ ";                                       break;
         case 5013:  Description="/ ";                                       break;
         case 5014:  Description="/";                                                break;
         case 5015:  Description="/  ";                                   break;
         case 5016:  Description="/  ";                                    break;
         case 5017:  Description="//";                                           break;
         case 5018:  Description="    ";                                 break;
         case 5019:  Description="    ";                                  break;
         case 5020:  Description="/   ";                                 break;
         case 5021:  Description="/   ";                                  break;
         case 5022:  Description="    ";                              break;
         case 5023:  Description="/";                                                  break;
         case 5024:  Description="   ";                                     break;
         case 5025:  Description="  ";                                      break;
         case 5026:  Description="  ";                                   break;
         case 5027:  Description="/ ";                                      break;
         case 5028:  Description="/ ";                                   break;
         case 5029:  Description="    ";                                  break;
         case 5030:  Description="    ";                                 break;
         case 5031:  Description=" ";                                                  break;
         case 5032:  Description=" -";                                           break;
         case 5033:  Description=" -";                                        break;
         case 5034:  Description="  ()";                               break;
         case 5035:  Description="  -";                                         break;
         case 5036:  Description="  -";                                      break;
         case 5037:  Description="  ";                                        break;
         case 5038:  Description="   ";                               break;
         case 5039:  Description="   ";                               break;
         case 5040:  Description="  ";                                     break;
         case 5041:  Description="   ";                            break;
         case 5042:  Description="   ";                            break;
         case 5043:  Description="  ";                                         break;
         case 5044:  Description="  ";                                    break;
         case 5045:  Description="   ()";                        break;
         case 5046:  Description="   ()";                      break;
         case 5047:  Description="    ";                                  break;
         case 5048:  Description="    ";                               break;
         case 5049:  Description="/   ";                                  break;
         case 5050:  Description="/   ";                               break;
         case 5051:  Description="  ()";                                      break;
         case 5052:  Description="  ()";                                    break;
         case 5053:  Description=" ";                                                break;
         case 5054:  Description="   ";                                           break;
         case 5055:  Description="   ";                                          break;
         case 5056:  Description="   ";                          break;
         case 5057:  Description="   ";                             break;
         case 5058:  Description="   ";                                 break;
         case 5059:  Description="  ";                                            break;
         case 5060:  Description="   ";                                     break;
         case 5061:  Description="   ";                                 break;
         case 5062:  Description="   ";                                     break;
         case 5063:  Description=" ";                                           break;
         case 5064:  Description="  ";                                         break;
         case 5065:  Description="    ";                                     break;
         case 5066:  Description="  ";                                            break;
         case 5067:  Description=" -";                                           break;
         case 5068:  Description="  ";                                       break;
 //---------------------------------------------------------------------------------------------        
         case 5091:  Description=",    !";             break;
         case 5092:  Description=",  !";                       break;
         case 5093:  Description=",     !";         break;
         case 5094:  Description=" ...";                                 break;
         case 5095:  Description="   ...";                                   break;
 //---------------------------------------------------------------------------------------------
         case 4017:  Description="     DLL";             break; 
         default:    Description=" ";                                    break;
        }
     break;
     
     case 1: // 
       switch(uid)
        {
         case 5000:  Description=" Shooting Star";                                         break;
         case 5001:  Description=" Hanging Man";                                           break;
         case 5002:  Description=" Hummer";                                                break;
         case 5003:  Description=" InvertedHummer";                                        break;
         case 5004:  Description=" Morning Star";                                          break;
         case 5005:  Description=" Everning Star";                                         break;
         case 5006:  Description=" Harami";                                                break;
         case 5007:  Description=" HighPrice harami";                                      break;
         case 5008:  Description=" Cross harami";                                          break;
         case 5009:  Description=" LowPrice harami";                                       break;
         case 5010:  Description="/Tweezers";                                              break;
         case 5011:  Description="/Doji";                                                  break;
         case 5012:  Description="/Morning Star";                                          break;
         case 5013:  Description="/Everning Star";                                         break;
         case 5014:  Description="/Harami";                                                break;
         case 5015:  Description="/HighPrice harami";                                      break;
         case 5016:  Description="/LowPrice harami";                                       break;
         case 5017:  Description="/Tweezers/Doji";                                         break;
         case 5018:  Description=" Three inside up";                                       break;
         case 5019:  Description=" Three inside down";                                     break;
         case 5020:  Description="/Three inside up";                                       break;
         case 5021:  Description="/Three inside down";                                     break;
         case 5022:  Description=" Dark Cloud";                                            break;
         case 5023:  Description="/GAP";                                                   break;  
         case 5024:  Description=" Piercing Line";                                         break;
         case 5025:  Description=" Bullish Engulfing";                                     break;
         case 5026:  Description=" Bearish Engulfing";                                     break;
         case 5027:  Description="/Bullish Engulfing";                                     break;
         case 5028:  Description="/Bearish Engulfing";                                     break;
         case 5029:  Description=" Three outside down";                                    break;
         case 5030:  Description=" Three outside up";                                      break;
         case 5031:  Description=" Doji";                                                  break;
         case 5032:  Description=" DragonFly Doji";                                        break;
         case 5033:  Description=" Gravestone Doji";                                       break;
         case 5034:  Description=" Longlegs Doji";                                         break;
         case 5035:  Description=" Bullish pin-bar";                                       break;
         case 5036:  Description=" Bearish pin-bar";                                       break; 
         case 5037:  Description=" Bullish maribozu";                                      break;
         case 5038:  Description=" Bullish opening maribozu";                              break;
         case 5039:  Description=" Bullish closing maribozu";                              break;
         case 5040:  Description=" Bearish maribozu";                                      break;
         case 5041:  Description=" Bearish opening maribozu";                              break;
         case 5042:  Description=" Bearish closing maribozu";                              break;
         case 5043:  Description=" High Wave";                                             break;                                 
         case 5044:  Description=" Abandoned baby";                                        break;
         case 5045:  Description=" Last engulfing top";                                    break;
         case 5046:  Description=" Last engulfing bottom";                                 break;
         case 5047:  Description=" Bullish belt-hold";                                     break;
         case 5048:  Description=" Bearish belt-hold";                                     break;
         case 5049:  Description="/Bullish belt-hold";                                     break;
         case 5050:  Description="/Bearish belt-hold";                                     break;
         case 5051:  Description=" Tweezers top";                                          break;
         case 5052:  Description=" Tweezers bottom";                                       break;
         case 5053:  Description=" ThrustingLine";                                         break;
         case 5054:  Description=" On Neck Line";                                          break;
         case 5055:  Description=" In Neck Line";                                          break;
         case 5056:  Description=" Bearish MeetingLine";                                   break;
         case 5057:  Description=" Bullish MeetingLine";                                   break;
         case 5058:  Description=" Upside gap two crows";                                  break;
         case 5059:  Description=" Two crows";                                             break;
         case 5060:  Description=" Three black crows";                                     break;
         case 5061:  Description=" Identical Three Crows";                                 break;
         case 5062:  Description=" Three White Soldiers";                                  break;
         case 5063:  Description=" Dileberation";                                          break;
         case 5064:  Description=" Advance block";                                         break;
         case 5065:  Description=" Three Stars in the South";                              break;
         case 5066:  Description=" Three Stars";                                           break;
         case 5067:  Description=" Doji Star";                                             break;
         case 5068:  Description=" Homing Pigeon";                                         break;
 //---------------------------------------------------------------------------------------------        
         case 5091:  Description=",Requested history data in update state!";               break;
         case 5092:  Description=",No history data!";                                      break;
         case 5093:  Description=",Wrong SymbolName!";                                     break;
         case 5094:  Description="WAITING FOR UPDATE...";                                  break;
         case 5095:  Description=" DataBase connect...";                                   break;
 //---------------------------------------------------------------------------------------------
         case 4017:  Description="dll calls are not allowed";                              break;
         default:    Description="Unknow";                                                 break;
      } 
     break; 
    }
    return(Description);
   }
   
